#pragma once

#include "CoreMinimal.h"
#include "IgnoreCollisionsComponent.h"
#include "Templates/SubclassOf.h"
#include "IgnoreBreakablesCollisionsComponent.generated.h"

class UIgnoreCollisionsBreakableHandlerComponent;

UCLASS(Blueprintable, EditInlineNew, meta=(BlueprintSpawnableComponent))
class DBDGAMEPLAY_API UIgnoreBreakablesCollisionsComponent : public UIgnoreCollisionsComponent
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UIgnoreCollisionsBreakableHandlerComponent> _collisionHandlerComponentClass;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	TArray<UIgnoreCollisionsBreakableHandlerComponent*> _collisionHandlerComponents;

private:
	UFUNCTION(BlueprintCallable)
	void OnLevelReadyToPlay();

public:
	UIgnoreBreakablesCollisionsComponent();
};

FORCEINLINE uint32 GetTypeHash(const UIgnoreBreakablesCollisionsComponent) { return 0; }
